diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/editor/definedterm/input/TermEditorInput.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/editor/definedterm/input/TermEditorInput.java
index 235714cfe..a659f235c 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/editor/definedterm/input/TermEditorInput.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/editor/definedterm/input/TermEditorInput.java
@@ -17,7 +17,7 @@ import java.util.Set;
 import eu.etaxonomy.cdm.api.service.IVocabularyService;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.term.DefinedTerm;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.model.term.TermType;
 import eu.etaxonomy.cdm.model.term.TermVocabulary;
 import eu.etaxonomy.cdm.model.term.VocabularyEnum;
@@ -39,8 +39,8 @@ public class TermEditorInput extends AbstractDefinedTermEditorInput<DefinedTerm>
 
 	// FIXME: the default feature should be move to CdmApplicationState
 	//        where it is a singleton instance variable
-	private static FeatureTree defaultFeatureTree = null;
-	private static FeatureTree defaultNameFeatureTree = null;
+	private static TermTree<Feature> defaultFeatureTree = null;
+	private static TermTree<Feature> defaultNameFeatureTree = null;
 
 	private List<String> termClasses = Arrays.asList(new String[]{
 			DefinedTerm.class.getName()
@@ -98,7 +98,7 @@ public class TermEditorInput extends AbstractDefinedTermEditorInput<DefinedTerm>
         updateDefaultFeatureTree();
     }
 
-    public static FeatureTree getDefaultFeatureTree() {
+    public static TermTree<Feature> getDefaultFeatureTree() {
         if(defaultFeatureTree == null) {
             List<Feature> features = TermStore.getTerms(Feature.class);
             List<Feature> nameFeatures = CdmStore.getTermManager().getPreferredTerms(CdmStore.getService(IVocabularyService.class).load(VocabularyEnum.NameFeature.getUuid()), null);
@@ -108,15 +108,15 @@ public class TermEditorInput extends AbstractDefinedTermEditorInput<DefinedTerm>
                     features.remove(feature);
                 }
             }
-            defaultFeatureTree = FeatureTree.NewInstance(features);
+            defaultFeatureTree = TermTree.NewInstance(features);
         }
         return defaultFeatureTree;
     }
 
-    public static FeatureTree getDefaultNameFeatureTree() {
+    public static TermTree<Feature> getDefaultNameFeatureTree() {
         if(defaultNameFeatureTree == null) {
             List<Feature> nameFeatures = CdmStore.getTermManager().getPreferredTerms(CdmStore.getService(IVocabularyService.class).load(VocabularyEnum.NameFeature.getUuid()), null);
-            defaultNameFeatureTree = FeatureTree.NewInstance(nameFeatures);
+            defaultNameFeatureTree = TermTree.NewInstance(nameFeatures);
         }
         return defaultNameFeatureTree;
     }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/CharacterTransfer.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/CharacterTransfer.java
index d8ac8d129..c4f614b51 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/CharacterTransfer.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/CharacterTransfer.java
@@ -23,9 +23,10 @@ import org.eclipse.swt.dnd.ByteArrayTransfer;
 import org.eclipse.swt.dnd.TransferData;
 
 import eu.etaxonomy.cdm.api.service.IFeatureNodeService;
-import eu.etaxonomy.cdm.model.term.Representation;
 import eu.etaxonomy.cdm.model.description.Character;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.term.DefinedTerm;
+import eu.etaxonomy.cdm.model.term.Representation;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
 import eu.etaxonomy.taxeditor.store.CdmStore;
 
@@ -100,8 +101,8 @@ public class CharacterTransfer extends ByteArrayTransfer {
                         String string = in.readUTF();
                         String[] split = string.split(",");
                         IFeatureNodeService featureNodeService = CdmStore.getService(IFeatureNodeService.class);
-                        FeatureNode structure = featureNodeService.load(UUID.fromString(split[0]));
-                        FeatureNode property = featureNodeService.load(UUID.fromString(split[1]));
+                        TermNode<DefinedTerm> structure = featureNodeService.load(UUID.fromString(split[0]));
+                        TermNode<DefinedTerm> property = featureNodeService.load(UUID.fromString(split[1]));
                         Representation structureRepresentation = structure.getTerm().getRepresentation(PreferencesUtil.getGlobalLanguage());
                         Representation propertyRepresentation = property.getTerm().getRepresentation(PreferencesUtil.getGlobalLanguage());
                         String label = null;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureNodeTransfer.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureNodeTransfer.java
index 5d8a0f085..cacd6e2de 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureNodeTransfer.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureNodeTransfer.java
@@ -12,7 +12,8 @@ package eu.etaxonomy.taxeditor.featuretree;
 import java.util.UUID;
 
 import eu.etaxonomy.cdm.api.service.IFeatureNodeService;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.model.CdmObjectTransfer;
 import eu.etaxonomy.taxeditor.store.CdmStore;
 
@@ -21,9 +22,8 @@ import eu.etaxonomy.taxeditor.store.CdmStore;
  *
  * @author n.hoffmann
  * @created Aug 5, 2010
- * @version 1.0
  */
-public class FeatureNodeTransfer extends CdmObjectTransfer<FeatureNode> {
+public class FeatureNodeTransfer extends CdmObjectTransfer<TermNode<Feature>> {
 
 	private static FeatureNodeTransfer instance = new FeatureNodeTransfer();
 	private static final String TYPE_NAME = "featureNode-transfer-format";
@@ -53,11 +53,8 @@ public class FeatureNodeTransfer extends CdmObjectTransfer<FeatureNode> {
 		return new String[] { TYPE_NAME };
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.taxeditor.model.CdmObjectTransfer#loadElement(java.util.UUID)
-	 */
 	@Override
-	public FeatureNode loadElement(UUID uuid) {
+	public TermNode<Feature> loadElement(UUID uuid) {
 		return  CdmStore.getService(IFeatureNodeService.class).load(uuid);
 	}
 }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureTreeContentProvider.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureTreeContentProvider.java
index 2b78666f0..ce357273e 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureTreeContentProvider.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureTreeContentProvider.java
@@ -14,8 +14,9 @@ import java.util.List;
 import org.eclipse.jface.viewers.ITreeContentProvider;
 import org.eclipse.jface.viewers.Viewer;
 
-import eu.etaxonomy.cdm.model.term.FeatureNode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermNode;
+import eu.etaxonomy.cdm.model.term.TermTree;
 
 /**
  * <p>FeatureTreeContentProvider class.</p>
@@ -44,9 +45,6 @@ public class FeatureTreeContentProvider implements ITreeContentProvider {
 
 	}
 
-	/* (non-Javadoc)
-	 * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
-	 */
 	/** {@inheritDoc} */
 	@Override
 	public Object[] getElements(Object inputElement) {
@@ -56,14 +54,14 @@ public class FeatureTreeContentProvider implements ITreeContentProvider {
 	/** {@inheritDoc} */
 	@Override
 	public Object[] getChildren(Object parentElement) {
-		if(parentElement instanceof FeatureTree){
-			List<FeatureNode> children = ((FeatureTree) parentElement).getRootChildren();
+		if(parentElement instanceof TermTree){
+			List<TermNode<Feature>> children = ((TermTree<Feature>) parentElement).getRootChildren();
 			return children.toArray();
-		}else if(parentElement instanceof FeatureNode){
-			List<FeatureNode> children = ((FeatureNode) parentElement).getChildNodes();
+		}else if(parentElement instanceof TermNode){
+			List<TermNode<Feature>> children = ((TermNode<Feature>) parentElement).getChildNodes();
 			return children.toArray();
 		}else if(parentElement instanceof List){
-			return ((List) parentElement).toArray();
+			return ((List<TermNode<Feature>>) parentElement).toArray();
 		}else{
 			return new Object[]{};
 		}
@@ -72,8 +70,8 @@ public class FeatureTreeContentProvider implements ITreeContentProvider {
 	/** {@inheritDoc} */
 	@Override
 	public Object getParent(Object element) {
-	    if(element instanceof FeatureNode){
-	        return ((FeatureNode) element).getParent();
+	    if(element instanceof TermNode){
+	        return ((TermNode<Feature>) element).getParent();
 	    }
 		return null;
 	}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureTreeLabelProvider.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureTreeLabelProvider.java
index d97bb2e73..7139a9783 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureTreeLabelProvider.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureTreeLabelProvider.java
@@ -13,11 +13,11 @@ import java.util.ArrayList;
 
 import org.eclipse.jface.viewers.LabelProvider;
 
-import eu.etaxonomy.cdm.model.term.DefinedTermBase;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.term.DefinedTermBase;
 import eu.etaxonomy.cdm.model.term.Representation;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.term.TermNode;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
 
 /**
@@ -31,10 +31,10 @@ public class FeatureTreeLabelProvider extends LabelProvider {
 	/** {@inheritDoc} */
 	@Override
 	public String getText(Object element) {
-		if(element instanceof FeatureTree){
-			return ((FeatureTree) element).getTitleCache();
-		}else if(element instanceof FeatureNode){
-		    DefinedTermBase term = ((FeatureNode) element).getTerm();
+		if(element instanceof TermTree){
+			return ((TermTree) element).getTitleCache();
+		}else if(element instanceof TermNode){
+		    DefinedTermBase term = ((TermNode) element).getTerm();
 		    if(term!=null){
 		        Representation rep = term.getRepresentation(PreferencesUtil.getGlobalLanguage());
 		        if (rep == null){
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureTreePropertyTester.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureTreePropertyTester.java
index b1dbdd68c..a7240e246 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureTreePropertyTester.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/FeatureTreePropertyTester.java
@@ -6,7 +6,7 @@ package eu.etaxonomy.taxeditor.featuretree;
 import org.eclipse.core.expressions.PropertyTester;
 import org.eclipse.jface.viewers.IStructuredSelection;
 
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.term.TermTree;
 
 /**
  * Property tester used by the feature tree menu.
@@ -40,7 +40,7 @@ public class FeatureTreePropertyTester extends PropertyTester {
 
 	private boolean isFeatureTree(Object[] selectedElements) {
 	    for (Object object : selectedElements){
-	        if(!(object instanceof FeatureTree)){
+	        if(!(object instanceof TermTree)){
 	            return false;
 	        }
 	    }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureNodeDragListener.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureNodeDragListener.java
index 6987524df..e4dab040b 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureNodeDragListener.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureNodeDragListener.java
@@ -13,7 +13,8 @@ import org.eclipse.jface.viewers.TreeViewer;
 import org.eclipse.swt.dnd.DragSourceAdapter;
 import org.eclipse.swt.dnd.DragSourceEvent;
 
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.featuretree.FeatureNodeTransfer;
 
 public class FeatureNodeDragListener extends DragSourceAdapter {
@@ -31,7 +32,7 @@ public class FeatureNodeDragListener extends DragSourceAdapter {
     public void dragSetData(DragSourceEvent event) {
         IStructuredSelection selection = (IStructuredSelection) viewer.getSelection();
         if(selection!=null && !selection.isEmpty()){
-            FeatureNode[] featureNodes = (FeatureNode[]) selection.toList().toArray(new FeatureNode[selection.size()]);
+            TermNode<Feature>[] featureNodes = (TermNode<Feature>[]) selection.toList().toArray(new TermNode[selection.size()]);
             if (FeatureNodeTransfer.getInstance().isSupportedType(event.dataType)) {
                 event.data = featureNodes;
             }
@@ -45,7 +46,7 @@ public class FeatureNodeDragListener extends DragSourceAdapter {
 	public void dragStart(DragSourceEvent event) {
         event.doit = !viewer.getSelection().isEmpty()
                 && ((IStructuredSelection) viewer.getSelection()).toList()
-                .stream().allMatch(element -> element instanceof FeatureNode);
+                .stream().allMatch(element -> element instanceof TermNode);
 	}
 
 }
\ No newline at end of file
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureTreeDropAdapter.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureTreeDropAdapter.java
index 3c4257ce8..fb3f1d764 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureTreeDropAdapter.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureTreeDropAdapter.java
@@ -21,10 +21,10 @@ import org.eclipse.jface.viewers.ViewerDropAdapter;
 import org.eclipse.swt.dnd.TransferData;
 
 import eu.etaxonomy.cdm.model.description.Feature;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
 import eu.etaxonomy.cdm.model.term.IHasTermType;
 import eu.etaxonomy.cdm.model.term.OrderedTermVocabulary;
+import eu.etaxonomy.cdm.model.term.TermNode;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.model.term.TermType;
 import eu.etaxonomy.cdm.model.term.TermVocabulary;
 import eu.etaxonomy.cdm.persistence.dto.TermDto;
@@ -58,18 +58,18 @@ public class FeatureTreeDropAdapter extends ViewerDropAdapter {
 	        return false;
 	    }
 		Object currentTarget = getCurrentTarget();
-		FeatureNode target = null;
-		if(currentTarget instanceof FeatureTree){
-		    target = ((FeatureTree) currentTarget).getRoot();
+		TermNode<Feature> target = null;
+		if(currentTarget instanceof TermTree){
+		    target = ((TermTree) currentTarget).getRoot();
 		}
-		else if(currentTarget instanceof FeatureNode){
-		    target = (FeatureNode) currentTarget;
+		else if(currentTarget instanceof TermNode){
+		    target = (TermNode) currentTarget;
 		}
 		int position = 0;
 
 		if (target != null) {
 			int location = getCurrentLocation();
-			FeatureNode parent = target.getParent();
+			TermNode<Feature> parent = target.getParent();
 			if(parent!=null){
 			    if (location == LOCATION_BEFORE) {
 			        position = Math.max(0, parent.getIndex(target));
@@ -125,8 +125,8 @@ public class FeatureTreeDropAdapter extends ViewerDropAdapter {
                     continue;
                 }
 		    }
-		    if(droppedObject instanceof FeatureNode){
-		        FeatureNode droppedNode = (FeatureNode) droppedObject;
+		    if(droppedObject instanceof TermNode){
+		    	TermNode<Feature> droppedNode = (TermNode<Feature>) droppedObject;
 		        int currentPosition = target.getIndex(droppedNode);
 		        if(currentPosition<position){
 		            position -= 1;
@@ -185,7 +185,7 @@ public class FeatureTreeDropAdapter extends ViewerDropAdapter {
         isSupported |= TermTransfer.getInstance().isSupportedType(transferData);
         isSupported |= LocalSelectionTransfer.getTransfer().isSupportedType(transferData);
         isSupported &= getViewer().getInput()!=null;
-        if(target instanceof FeatureTree && getCurrentLocation()!=ViewerDropAdapter.LOCATION_ON){
+        if(target instanceof TermTree && getCurrentLocation()!=ViewerDropAdapter.LOCATION_ON){
             isSupported = false;
         }
         return isSupported;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureTreeEditor.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureTreeEditor.java
index a57bdd9b6..88b1bf7c7 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureTreeEditor.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureTreeEditor.java
@@ -48,8 +48,9 @@ import eu.etaxonomy.cdm.api.conversation.IConversationEnabled;
 import eu.etaxonomy.cdm.api.service.IFeatureTreeService;
 import eu.etaxonomy.cdm.api.service.ITermService;
 import eu.etaxonomy.cdm.model.description.Character;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermNode;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.model.term.TermType;
 import eu.etaxonomy.cdm.persistence.hibernate.CdmDataChangeMap;
 import eu.etaxonomy.taxeditor.editor.definedterm.FeatureTreeViewerComparator;
@@ -135,7 +136,7 @@ public class FeatureTreeEditor implements IFeatureTreeEditor, ISelectionChangedL
             }
         });
 
-        List<FeatureTree> trees = CdmStore.getService(IFeatureTreeService.class).list(FeatureTree.class, null, null, null, null);
+        List<TermTree> trees = CdmStore.getService(IFeatureTreeService.class).list(TermTree.class, null, null, null, null);
         viewer.setComparator(new FeatureTreeViewerComparator());
         viewer.setInput(trees);
 
@@ -150,15 +151,15 @@ public class FeatureTreeEditor implements IFeatureTreeEditor, ISelectionChangedL
 
         ISelection clipBoardSelection = LocalSelectionTransfer.getTransfer().getSelection();
         Object firstElement = selection.getFirstElement();
-        FeatureNode parentNode = null;
-        if(firstElement instanceof FeatureNode){
-            parentNode = (FeatureNode) firstElement;
+        TermNode<Feature> parentNode = null;
+        if(firstElement instanceof TermNode){
+            parentNode = (TermNode<Feature>) firstElement;
         }
-        else if(firstElement instanceof FeatureTree){
-            parentNode = ((FeatureTree)firstElement).getRoot();
+        else if(firstElement instanceof TermTree){
+            parentNode = ((TermTree<Feature>)firstElement).getRoot();
         }
         if(parentNode!=null){
-            FeatureNode copiedNode = (FeatureNode) ((IStructuredSelection)clipBoardSelection).getFirstElement();
+        	TermNode<Feature> copiedNode = (TermNode<Feature>) ((IStructuredSelection)clipBoardSelection).getFirstElement();
 
             AddFeatureOperation operation = new AddFeatureOperation(copiedNode.getTerm().getUuid(), parentNode, this, this);
             AbstractUtility.executeOperation(operation, sync);
@@ -248,14 +249,14 @@ public class FeatureTreeEditor implements IFeatureTreeEditor, ISelectionChangedL
         // commit the conversation and start a new transaction immediately
         conversation.commit(true);
 
-        CdmStore.getService(IFeatureTreeService.class).saveOrUpdate(getRootEntities());
+        CdmStore.getService(IFeatureTreeService.class).saveOrUpdate((List)getRootEntities());
 
-        List<FeatureTree> rootEntities = getRootEntities();
-        for (FeatureTree featureTree : rootEntities) {
+        List<TermTree<Feature>> rootEntities = getRootEntities();
+        for (TermTree featureTree : rootEntities) {
             if(featureTree.getTermType().equals(TermType.Character)){
-                FeatureTree<Character> characterTree = featureTree;
+                TermTree<Character> characterTree = featureTree;
                 //save characters because they can be modified in this editor
-                characterTree.getDistinctFeatures().forEach(character->CdmStore.getService(ITermService.class).merge(character,true));
+                characterTree.getDistinctTerms().forEach(character->CdmStore.getService(ITermService.class).merge(character,true));
             }
         }
 
@@ -267,7 +268,7 @@ public class FeatureTreeEditor implements IFeatureTreeEditor, ISelectionChangedL
     private void initializeTrees() {
         Object[] expandedElements = viewer.getExpandedElements();
         viewer.getTree().removeAll();
-        List<FeatureTree> trees = CdmStore.getService(IFeatureTreeService.class).list(FeatureTree.class, null, null, null, null);
+        List<TermTree> trees = CdmStore.getService(IFeatureTreeService.class).list(TermTree.class, null, null, null, null);
         viewer.setInput(trees);
         viewer.setExpandedElements(expandedElements);
     }
@@ -292,13 +293,13 @@ public class FeatureTreeEditor implements IFeatureTreeEditor, ISelectionChangedL
         });
         Map<Object, List<String>> propertyPathMap =
                 new HashMap<Object, List<String>>();
-        propertyPathMap.put(FeatureNode.class,propertyPaths);
+        propertyPathMap.put(TermNode.class,propertyPaths);
         return propertyPathMap;
     }
 
     @Override
-    public List<FeatureTree> getRootEntities() {
-        return (List<FeatureTree>) viewer.getInput();
+    public List<TermTree<Feature>> getRootEntities() {
+        return (List<TermTree<Feature>>) viewer.getInput();
     }
 
     @Override
@@ -347,9 +348,9 @@ public class FeatureTreeEditor implements IFeatureTreeEditor, ISelectionChangedL
     public boolean postOperation(Object objectAffectedByOperation) {
         initializeTrees();
         viewer.refresh();
-        if(objectAffectedByOperation instanceof FeatureNode){
-            FeatureNode node = (FeatureNode)objectAffectedByOperation;
-            viewer.expandToLevel(node.getFeatureTree(), 1);
+        if(objectAffectedByOperation instanceof TermNode){
+        	TermNode<Feature> node = (TermNode)objectAffectedByOperation;
+            viewer.expandToLevel(node.getGraph(), 1);
         }
         if(objectAffectedByOperation!=null){
             StructuredSelection selection = new StructuredSelection(objectAffectedByOperation);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureTreeEditorComposite.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureTreeEditorComposite.java
index c89e67f89..5b88ecdf5 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureTreeEditorComposite.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/FeatureTreeEditorComposite.java
@@ -29,8 +29,8 @@ import org.eclipse.swt.widgets.Text;
 import org.eclipse.swt.widgets.Tree;
 
 import eu.etaxonomy.cdm.model.term.DefinedTermBase;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.model.term.TermType;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
 import eu.etaxonomy.taxeditor.editor.definedterm.TermTransfer;
 import eu.etaxonomy.taxeditor.featuretree.FeatureNodeTransfer;
 import eu.etaxonomy.taxeditor.featuretree.FeatureTreeContentProvider;
@@ -43,11 +43,10 @@ import eu.etaxonomy.taxeditor.ui.dialog.selection.FeatureTreeSelectionDialog;
 /**
  * @author pplitzner
  * @since Jun 19, 2017
- *
  */
 public class FeatureTreeEditorComposite <T extends DefinedTermBase> extends Composite{
 
-    private FeatureTree<T> featureTree;
+    private TermTree<T> featureTree;
 
     private Label label_title;
     private Text text_title;
@@ -181,7 +180,7 @@ public class FeatureTreeEditorComposite <T extends DefinedTermBase> extends Comp
             btnOpenFeatureTree.addSelectionListener(new SelectionAdapter(){
                 @Override
                 public void widgetSelected(SelectionEvent e) {
-                    FeatureTree<T> tree = FeatureTreeSelectionDialog.select(getDisplay().getActiveShell(),
+                    TermTree<T> tree = FeatureTreeSelectionDialog.select(getDisplay().getActiveShell(),
                             null, termType);
                     if(tree!=null){
                         setSelectedTree(tree);
@@ -194,7 +193,7 @@ public class FeatureTreeEditorComposite <T extends DefinedTermBase> extends Comp
         }
     }
 
-    public void setSelectedTree(FeatureTree<T> featureTree) {
+    public void setSelectedTree(TermTree<T> featureTree) {
         this.featureTree = featureTree;
 
         viewer.setInput(featureTree);
@@ -209,7 +208,7 @@ public class FeatureTreeEditorComposite <T extends DefinedTermBase> extends Comp
         }
     }
 
-    public FeatureTree<T> getFeatureTree() {
+    public TermTree<T> getFeatureTree() {
         return featureTree;
     }
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/AddChildFeatureHandler.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/AddChildFeatureHandler.java
index 3a36b5e20..ed9a135bf 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/AddChildFeatureHandler.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/AddChildFeatureHandler.java
@@ -24,8 +24,9 @@ import org.eclipse.jface.viewers.IStructuredSelection;
 import org.eclipse.jface.wizard.WizardDialog;
 import org.eclipse.swt.widgets.Shell;
 
+import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.term.DefinedTermBase;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.featuretree.AvailableFeaturesWizard;
 import eu.etaxonomy.taxeditor.featuretree.e4.IFeatureTreeEditor;
 import eu.etaxonomy.taxeditor.featuretree.e4.operation.AddFeatureOperation;
@@ -34,8 +35,7 @@ import eu.etaxonomy.taxeditor.store.StoreUtil;
 
 /**
  * @author pplitzner
- * @since Jul 12, 2017
- *
+ * @since Jul 12, 2017 
  */
 public class AddChildFeatureHandler {
 
@@ -48,7 +48,7 @@ public class AddChildFeatureHandler {
         if (StoreUtil.promptCheckIsDirty(editor)) {
             return;
         }
-        FeatureNode parent = (FeatureNode)selection.getFirstElement();
+        TermNode<Feature> parent = (TermNode<Feature>)selection.getFirstElement();
 
 //        TermChooseWizard wizard = new TermChooseWizard(parent.getTermType());
 //        WizardDialog dialog = new WizardDialog(shell, wizard);
@@ -82,7 +82,7 @@ public class AddChildFeatureHandler {
         canExecute = thisPart.getObject() instanceof IFeatureTreeEditor
                 && selection!=null
                 && selection.size()==1
-                && selection.getFirstElement() instanceof FeatureNode;
+                && selection.getFirstElement() instanceof TermNode;
         menuItem.setVisible(canExecute);
         return canExecute;
     }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/AddFeatureHandler.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/AddFeatureHandler.java
index 0a7a1b54a..04dc31881 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/AddFeatureHandler.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/AddFeatureHandler.java
@@ -24,8 +24,9 @@ import org.eclipse.jface.viewers.IStructuredSelection;
 import org.eclipse.jface.wizard.WizardDialog;
 import org.eclipse.swt.widgets.Shell;
 
+import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.term.DefinedTermBase;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.featuretree.AvailableFeaturesWizard;
 import eu.etaxonomy.taxeditor.featuretree.e4.IFeatureTreeEditor;
 import eu.etaxonomy.taxeditor.featuretree.e4.operation.AddFeatureOperation;
@@ -47,7 +48,7 @@ public class AddFeatureHandler {
         if (StoreUtil.promptCheckIsDirty(editor)) {
             return;
         }
-        FeatureTree tree = (FeatureTree) selection.getFirstElement();
+        TermTree<Feature> tree = (TermTree<Feature>) selection.getFirstElement();
 //
 //        TermChooseWizard wizard = new TermChooseWizard(tree.getTermType());
 //        WizardDialog dialog = new WizardDialog(shell, wizard);
@@ -81,7 +82,7 @@ public class AddFeatureHandler {
         canExecute = thisPart.getObject() instanceof IFeatureTreeEditor
                 && selection!=null
                 && selection.size()==1
-                && selection.getFirstElement() instanceof FeatureTree;
+                && selection.getFirstElement() instanceof TermTree;
         menuItem.setVisible(canExecute);
         return canExecute;
     }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/CopyFeatureHandler.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/CopyFeatureHandler.java
index 1a607cb3c..dff2c0c8b 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/CopyFeatureHandler.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/e4/handler/CopyFeatureHandler.java
@@ -11,7 +11,7 @@ import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
 import org.eclipse.e4.ui.services.IServiceConstants;
 import org.eclipse.jface.viewers.IStructuredSelection;
 
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.featuretree.e4.FeatureTreeEditor;
 
 public class CopyFeatureHandler {
@@ -30,7 +30,7 @@ public class CopyFeatureHandler {
         canExecute =part.getObject() instanceof FeatureTreeEditor
                 && selection!=null
                 && selection.size()==1
-                && selection.getFirstElement() instanceof FeatureNode;
+                && selection.getFirstElement() instanceof TermNode;
         menuItem.setVisible(canExecute);
         return canExecute;
     }
